Index: trunk/source/processes/hadronic/cross_sections/include/G4NeutronInelasticXS.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4NeutronInelasticXS.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4NeutronInelasticXS.hh	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4NeutronInelasticXS.hh,v 1.3 2009/11/19 11:52:27 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4NeutronInelasticXS.hh,v 1.6 2010/10/15 22:33:22 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -38,6 +38,10 @@
 // Modifications:
 //
+
+// Class Description:
+// This is a base class for neutron inelastic hadronic cross section based on
+// data files from G4NEUTRONXSDATA data set 
+// Class Description - End
  
-
 #ifndef G4NeutronInelasticXS_h
 #define G4NeutronInelasticXS_h 1
@@ -45,4 +49,5 @@
 #include "G4VCrossSectionDataSet.hh"
 #include "globals.hh"
+#include <vector>
 
 class G4DynamicParticle;
@@ -51,25 +56,22 @@
 class G4PhysicsVector;
 class G4GlauberGribovCrossSection;
+class G4HadronNucleonXsc;
 
 class G4NeutronInelasticXS : public G4VCrossSectionDataSet
 {
-public: // With Description
+public: 
 
-  G4int Z;
   G4NeutronInelasticXS();
 
   virtual ~G4NeutronInelasticXS();
 
-  // The following methods need to be implemented for each new data set.
   virtual
   G4bool IsApplicable(const G4DynamicParticle*, const G4Element*);
 
   virtual
-  G4bool IsZAApplicable(const G4DynamicParticle*, 
-			G4double /*Z*/, G4double /*A*/);
+  G4bool IsIsoApplicable(const G4DynamicParticle*, G4int /*Z*/, G4int /*A*/);
 
   virtual
-  G4double GetCrossSection(const G4DynamicParticle*, 
-			   const G4Element*, 
+  G4double GetCrossSection(const G4DynamicParticle*, const G4Element*, 
 	 		   G4double aTemperature = 0.);
 
@@ -80,16 +82,5 @@
   void DumpPhysicsTable(const G4ParticleDefinition&);
 
-public: // Without Description
-
-  inline void SetVerboseLevel(G4int value)
-  {
-    verboseLevel = value;
-  }
-  inline G4int GetVerboseLevel()
-  {
-    return verboseLevel;
-  }
-
-private: // Without Description
+private: 
 
   void Initialise(G4int Z, G4DynamicParticle* dp = 0, const char* = 0);
@@ -99,7 +90,11 @@
   
   G4GlauberGribovCrossSection* ggXsection;
+  G4HadronNucleonXsc* fNucleon;
 
-  G4PhysicsVector* data[93];
-  G4double         coeff[93];
+  const G4ParticleDefinition* proton;
+
+  std::vector<G4PhysicsVector*> data;
+  std::vector<G4double>         coeff;
+  G4int   maxZ;
 
   G4bool  isInitialized;
Index: trunk/source/processes/hadronic/cross_sections/include/G4NucleonNuclearCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4NucleonNuclearCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4NucleonNuclearCrossSection.hh	(revision 1340)
@@ -52,7 +52,9 @@
   virtual ~G4NucleonNuclearCrossSection();
 
-  virtual G4bool IsApplicable(const G4DynamicParticle* aParticle, const G4Element* anElement);
-
-  virtual G4bool IsZAApplicable(const G4DynamicParticle* aParticle, G4double Z, G4double A);
+  virtual G4bool IsApplicable(const G4DynamicParticle* aParticle,
+                              const G4Element* anElement);
+
+  virtual G4bool IsIsoApplicable(const G4DynamicParticle* aParticle,
+                                 G4int Z, G4int A);
 
   G4double GetCrossSection(const G4DynamicParticle* aParticle, 
@@ -60,9 +62,9 @@
                            G4double T=0.);
 
-  G4double GetIsoZACrossSection(const G4DynamicParticle* aParticle, 
-                                G4double ZZ, G4double AA, G4double T=0. );
+  G4double GetZandACrossSection(const G4DynamicParticle* aParticle, 
+                                G4int ZZ, G4int AA, G4double T=0. );
 
   G4double GetElasticCrossSection(const G4DynamicParticle* aParticle, 
-				  G4double ZZ, G4double AA);
+				  G4int ZZ, G4int AA);
 
   G4double GetTotalXsc()  { return fTotalXsc;   };
@@ -190,7 +192,7 @@
 inline
 G4double G4NucleonNuclearCrossSection::GetElasticCrossSection(
-         const G4DynamicParticle* dp, G4double ZZ, G4double AA)
+         const G4DynamicParticle* dp, G4int ZZ, G4int AA)
 {
-  GetIsoZACrossSection(dp, ZZ, AA);
+  GetZandACrossSection(dp, ZZ, AA);
   return fElasticXsc;
 }
Index: trunk/source/processes/hadronic/cross_sections/include/G4PhotoNuclearCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4PhotoNuclearCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4PhotoNuclearCrossSection.hh	(revision 1340)
@@ -25,5 +25,5 @@
 //
 //
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 //
@@ -53,9 +53,9 @@
   G4bool IsApplicable(const G4DynamicParticle* particle, const G4Element* )
   {
-    return IsZAApplicable(particle, 0, 0);
+    return IsIsoApplicable(particle, 0, 0);
   }
 
-  G4bool IsZAApplicable(const G4DynamicParticle* particle,
-                        G4double /*ZZ*/, G4double /*AA*/)
+  G4bool IsIsoApplicable(const G4DynamicParticle* particle,
+                         G4int /*ZZ*/, G4int /*AA*/)
   {
     G4bool result = false;
@@ -68,7 +68,7 @@
                            const G4Element* element, G4double temp = 0.);
 
-  G4double GetIsoZACrossSection(const G4DynamicParticle* particle,
-                                G4double ZZ, G4double AA,
-                                G4double /*aTemperature*/);
+
+  G4double GetZandACrossSection(const G4DynamicParticle* particle,
+                                G4int ZZ, G4int AA, G4double /*aTemperature*/);
 
 
@@ -78,10 +78,13 @@
 
 private:
-  G4int    GetFunctions(G4double a, G4double* y, G4double* z);
-  G4double EquLinearFit(G4double X, G4int N,const G4double X0,const G4double XD, const G4double* Y);
+
+  G4int GetFunctions(G4double a, G4double* y, G4double* z);
+  G4double EquLinearFit(G4double X, G4int N, const G4double X0,
+                        const G4double XD, const G4double* Y);
   G4double ThresholdEnergy(G4int Z, G4int N);
 
 // Body
 private:
+
   static G4int     lastN;   // The last N of calculated nucleus
   static G4int     lastZ;   // The last Z of calculated nucleus
@@ -93,6 +96,9 @@
   static G4double  lastSP;  // Last value of the ShadowingPomeron (A-dependent)
 
-  static std::vector <G4double*> GDR;   // Vector of pointers to the GDRPhotonuclearCrossSection
-  static std::vector <G4double*> HEN;   // Vector of pointers to the HighEnPhotonuclearCrossSect
+  // Vector of pointers to the GDRPhotonuclearCrossSection
+  static std::vector <G4double*> GDR;
+
+  // Vector of pointers to the HighEnPhotonuclearCrossSect
+  static std::vector <G4double*> HEN;
 
 };
Index: trunk/source/processes/hadronic/cross_sections/include/G4PiNuclearCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4PiNuclearCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4PiNuclearCrossSection.hh	(revision 1340)
@@ -42,5 +42,6 @@
   virtual ~G4PiNuclearCrossSection();
 
-  G4bool IsApplicable(const G4DynamicParticle* aParticle, const G4Element* anElement)
+  G4bool IsApplicable(const G4DynamicParticle* aParticle,
+                      const G4Element* anElement)
   {
     G4bool result = false;
@@ -52,14 +53,15 @@
   }
 
-  G4bool IsZAApplicable(const G4DynamicParticle* particle,
-                        G4double ZZ, G4double /*AA*/)
+  G4bool
+  IsIsoApplicable(const G4DynamicParticle* particle, G4int ZZ, G4int /*AA*/)
   {
     G4bool result = false;
     if(particle->GetDefinition() == G4PionMinus::PionMinus()) result=true;
     if(particle->GetDefinition() == G4PionPlus::PionPlus())   result=true;
-    if(G4lrint(ZZ) == 1) result = false;
+    if(ZZ == 1) result = false;
     if(particle->GetKineticEnergy() > 99.9*TeV) result=false;
     return result;
   }
+
 
   G4double GetCrossSection(const G4DynamicParticle* particle, 
@@ -67,14 +69,15 @@
                            G4double temperature)
   {
-    return GetIsoZACrossSection(particle, element->GetZ(), 
-                                element->GetN(), temperature);
+    G4int Z = G4lrint(element->GetZ());
+    G4int A = G4lrint(element->GetN());
+    return GetZandACrossSection(particle, Z, A, temperature);
   }
 
-  G4double GetIsoZACrossSection(const G4DynamicParticle* aParticle,
-                                G4double ZZ, G4double AA,
+  G4double GetZandACrossSection(const G4DynamicParticle* aParticle,
+                                G4int ZZ, G4int AA,
                                 G4double /*aTemperature*/);
 
-  G4double GetTotalXsc()  { return fTotalXsc;   };
-  G4double GetElasticXsc(){ return fElasticXsc; };
+  G4double GetTotalXsc() {return fTotalXsc;};
+  G4double GetElasticXsc() {return fElasticXsc;};
 
 
Index: trunk/source/processes/hadronic/cross_sections/include/G4ProtonInelasticCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4ProtonInelasticCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4ProtonInelasticCrossSection.hh	(revision 1340)
@@ -56,5 +56,5 @@
    {
      G4bool result = false;
-     if(( aPart->GetDefinition()==G4Proton::Proton()) &&
+     if ( (aPart->GetDefinition()==G4Proton::Proton()) &&
         ( aPart->GetKineticEnergy()<100*TeV) ) result = true;
      if(aEle->GetZ()<3) result = false;
@@ -62,6 +62,7 @@
    }
 
-   G4bool IsZAApplicable(const G4DynamicParticle* aParticle,
-                         G4double ZZ, G4double /*AA*/)
+
+   G4bool
+   IsIsoApplicable(const G4DynamicParticle* aParticle, G4int ZZ, G4int /*AA*/)
    {
      G4bool result = false;
@@ -72,11 +73,13 @@
    }
 
+
    virtual
    G4double GetCrossSection(const G4DynamicParticle*, 
                             const G4Element*, G4double aTemperature);
+
    
-   G4double GetIsoZACrossSection(const G4DynamicParticle* aParticle, 
-                                 G4double ZZ, G4double AA, 
-                                 G4double /*aTemperature*/)
+   G4double
+   GetZandACrossSection(const G4DynamicParticle* aParticle, 
+                        G4int ZZ, G4int AA, G4double /*aTemperature*/)
    {
      return GetCrossSection(aParticle->GetKineticEnergy(), AA, ZZ);
@@ -84,9 +87,11 @@
  
 
-   G4double GetCrossSection(G4double anEnergy, G4double anA, G4double aZ);
+   G4double GetCrossSection(G4double anEnergy, G4int anA, G4int aZ);
+
 
    virtual
    void BuildPhysicsTable(const G4ParticleDefinition&)
    {}
+
 
    virtual
Index: trunk/source/processes/hadronic/cross_sections/include/G4TripathiCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4TripathiCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4TripathiCrossSection.hh	(revision 1340)
@@ -49,13 +49,13 @@
    G4bool IsApplicable(const G4DynamicParticle* aPart, const G4Element*)
    {
-     return IsZAApplicable(aPart, 0., 0.);
+     return IsIsoApplicable(aPart, 0, 0);
    }
 
    virtual
-   G4bool IsZAApplicable(const G4DynamicParticle* aPart, G4double /*ZZ*/,
-                         G4double /*AA*/)
+   G4bool IsIsoApplicable(const G4DynamicParticle* aPart,
+                          G4int /*ZZ*/, G4int /*AA*/)
    {
      G4bool result = false;
-     if(( aPart->GetDefinition()->GetBaryonNumber()>2.5) &&
+     if ( (aPart->GetDefinition()->GetBaryonNumber()>2.5) &&
         ( aPart->GetKineticEnergy()/aPart->GetDefinition()->GetBaryonNumber()<1*GeV) ) result = true;
      return result;
@@ -68,6 +68,6 @@
 
    virtual
-   G4double GetIsoZACrossSection(const G4DynamicParticle*, G4double ZZ,
-                                 G4double AA, G4double aTemperature);
+   G4double GetZandACrossSection(const G4DynamicParticle*, G4int ZZ,
+                                 G4int AA, G4double aTemperature);
 
    virtual
Index: trunk/source/processes/hadronic/cross_sections/include/G4TripathiLightCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4TripathiLightCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4TripathiLightCrossSection.hh	(revision 1340)
@@ -86,6 +86,6 @@
       const G4Element* theTarget);
 
-    virtual G4bool IsZAApplicable(const G4DynamicParticle* theProjectile,
-      G4double ZZ, G4double AA);
+    virtual G4bool IsIsoApplicable(const G4DynamicParticle* theProjectile,
+                                   G4int ZZ, G4int AA);
 
     virtual G4double GetCrossSection(const G4DynamicParticle* theProjectile,
@@ -93,6 +93,6 @@
 
     virtual 
-    G4double GetIsoZACrossSection(const G4DynamicParticle* theProjectile,
-                                  G4double ZZ, G4double AA, 
+    G4double GetZandACrossSection(const G4DynamicParticle* theProjectile,
+                                  G4int ZZ, G4int AA, 
                                   G4double theTemperature);
 
@@ -102,5 +102,5 @@
     virtual void DumpPhysicsTable(const G4ParticleDefinition&)
     {G4cout << "G4TripathiLightCrossSection: uses formula"<<G4endl;}
-    void SetLowEnergyCheck (G4bool);
+    void SetLowEnergyCheck(G4bool);
 
   private:
@@ -110,5 +110,4 @@
     G4bool         lowEnergyCheck;
 };
-///////////////////////////////////////////////////////////////////////////////
-//
+
 #endif
Index: trunk/source/processes/hadronic/cross_sections/include/G4UElasticCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4UElasticCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4UElasticCrossSection.hh	(revision 1340)
@@ -61,5 +61,5 @@
 
   virtual
-  G4bool IsZAApplicable(const G4DynamicParticle*, G4double Z, G4double A);
+  G4bool IsIsoApplicable(const G4DynamicParticle*, G4int Z, G4int A);
 
   virtual
@@ -68,6 +68,6 @@
 
   virtual
-  G4double GetIsoZACrossSection(const G4DynamicParticle*, G4double /*Z*/,
-				G4double /*A*/, G4double aTemperature = 0.);
+  G4double GetZandACrossSection(const G4DynamicParticle*, G4int /*Z*/,
+                                G4int /*A*/, G4double aTemperature = 0.);
 
   virtual
Index: trunk/source/processes/hadronic/cross_sections/include/G4UInelasticCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4UInelasticCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4UInelasticCrossSection.hh	(revision 1340)
@@ -61,5 +61,5 @@
 
   virtual
-  G4bool IsZAApplicable(const G4DynamicParticle*, G4double Z, G4double A);
+  G4bool IsIsoApplicable(const G4DynamicParticle*, G4int Z, G4int A);
 
   virtual
@@ -68,6 +68,6 @@
 
   virtual
-  G4double GetIsoZACrossSection(const G4DynamicParticle*, G4double /*Z*/,
-				G4double /*A*/, G4double aTemperature = 0.);
+  G4double GetZandACrossSection(const G4DynamicParticle*, G4int /*Z*/,
+				G4int /*A*/, G4double aTemperature = 0.);
 
   virtual
@@ -90,6 +90,4 @@
   G4HadronCrossSections*          fGheisha;
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
 };
 
Index: trunk/source/processes/hadronic/cross_sections/include/G4UPiNuclearCrossSection.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4UPiNuclearCrossSection.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4UPiNuclearCrossSection.hh	(revision 1340)
@@ -39,4 +39,5 @@
 #include "G4DynamicParticle.hh"
 #include "G4DataVector.hh"
+#include "G4HadTmpUtil.hh"
 #include "globals.hh"
 #include <vector>
@@ -57,6 +58,6 @@
 
   virtual
-  G4bool IsZAApplicable(const G4DynamicParticle* aParticle, 
-			G4double Z, G4double A);
+  G4bool IsIsoApplicable(const G4DynamicParticle* aParticle, 
+                         G4int Z, G4int A);
 
   virtual 
@@ -65,6 +66,6 @@
 
   virtual 
-  G4double GetIsoZACrossSection(const G4DynamicParticle* aParticle, 
-				G4double Z, G4double A, G4double T=0.);
+  G4double GetZandACrossSection(const G4DynamicParticle* aParticle, 
+				G4int Z, G4int A, G4double T=0.);
 
   G4double GetElasticCrossSection(const G4DynamicParticle* aParticle, 
@@ -72,5 +73,5 @@
 
   G4double GetElasticCrossSection(const G4DynamicParticle* aParticle, 
-				  G4double Z, G4double A);
+				  G4int Z, G4int A);
 
   G4double GetInelasticCrossSection(const G4DynamicParticle* aParticle, 
@@ -78,5 +79,5 @@
 
   G4double GetInelasticCrossSection(const G4DynamicParticle* aParticle, 
-				    G4double Z, G4double A);
+				    G4int Z, G4int A);
 
   void BuildPhysicsTable(const G4ParticleDefinition&);
@@ -91,5 +92,5 @@
 		  const G4double* in, const G4double* e, G4int n); 
 
-  G4double Interpolate(G4double Z, G4double A, G4double ekin, 
+  G4double Interpolate(G4int Z, G4int A, G4double ekin, 
 		       G4PhysicsTable*);
 
@@ -115,14 +116,16 @@
 		     const G4Element* elm)
 {
-  return IsZAApplicable(part, elm->GetZ(), elm->GetN());
+  G4int Z = G4lrint(elm->GetZ());
+  G4int A = G4lrint(elm->GetN());
+  return IsIsoApplicable(part, Z, A);
 }
 
-inline G4bool G4UPiNuclearCrossSection::IsZAApplicable(
-		     const G4DynamicParticle* part, 
-		     G4double Z, G4double)
+inline G4bool
+G4UPiNuclearCrossSection::IsIsoApplicable(const G4DynamicParticle* part, 
+		                          G4int Z, G4int)
 {
   return ((part->GetDefinition() == piMinus || 
 	   part->GetDefinition() == piPlus) &&
-	   Z > 1.5);
+	   Z > 1);
 }
 
@@ -131,10 +134,12 @@
 		      const G4Element* elm, G4double)
 {
-  return GetInelasticCrossSection(dp, elm->GetZ(), elm->GetN());
+  G4int Z = G4lrint(elm->GetZ());
+  G4int A = G4lrint(elm->GetN());
+  return GetInelasticCrossSection(dp, Z, A);
 }
 
-inline G4double G4UPiNuclearCrossSection::GetIsoZACrossSection(
-		      const G4DynamicParticle* dp, 
-		      G4double Z, G4double A, G4double)
+inline G4double
+G4UPiNuclearCrossSection::GetZandACrossSection(const G4DynamicParticle* dp, 
+		                               G4int Z, G4int A, G4double)
 {
   return GetInelasticCrossSection(dp, Z, A);
@@ -145,5 +150,7 @@
 		      const G4Element* elm)
 {
-  return GetInelasticCrossSection(dp, elm->GetZ(), elm->GetN());
+  G4int Z = G4lrint(elm->GetZ());
+  G4int A = G4lrint(elm->GetN());
+  return GetInelasticCrossSection(dp, Z, A);
 }
 
@@ -152,5 +159,7 @@
 		      const G4Element* elm)
 {
-  return GetElasticCrossSection(dp, elm->GetZ(), elm->GetN());
+  G4int Z = G4lrint(elm->GetZ());
+  G4int A = G4lrint(elm->GetN());
+  return GetElasticCrossSection(dp, Z, A);
 }
 
Index: trunk/source/processes/hadronic/cross_sections/include/G4VCrossSectionDataSet.hh
===================================================================
--- trunk/source/processes/hadronic/cross_sections/include/G4VCrossSectionDataSet.hh	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/include/G4VCrossSectionDataSet.hh	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4VCrossSectionDataSet.hh,v 1.13 2009/01/24 11:54:47 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4VCrossSectionDataSet.hh,v 1.14 2010/07/05 13:39:11 vnivanch Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -38,4 +38,6 @@
 // Modifications:
 // 23.01.2009 V.Ivanchenko move constructor and destructor to source
+// 05.07.2010 V.Ivanchenko added name, min and max energy limit and
+//            corresponding access methods
 //
  
@@ -58,5 +60,5 @@
 public: //with description
 
-  G4VCrossSectionDataSet();
+  G4VCrossSectionDataSet(const G4String& nam = "");
 
   virtual ~G4VCrossSectionDataSet();
@@ -68,4 +70,7 @@
   virtual
   G4bool IsZAApplicable(const G4DynamicParticle*, G4double /*Z*/, G4double /*A*/);
+
+  virtual
+  G4bool IsIsoApplicable(const G4DynamicParticle*, G4int /*Z*/, G4int /*N*/);
 
   virtual
@@ -83,4 +88,8 @@
 
   virtual
+  G4double GetZandACrossSection(const G4DynamicParticle*, G4int /*Z*/,
+				G4int /*A*/, G4double aTemperature = 0.);
+
+  virtual
   void BuildPhysicsTable(const G4ParticleDefinition&) = 0;
 
@@ -90,18 +99,60 @@
 public: // Without Description
 
-  inline void SetVerboseLevel(G4int value)
-  {
-    verboseLevel = value;
-  }
+  inline void SetVerboseLevel(G4int value);
 
-  inline G4int GetVerboseLevel()
-  {
-    return verboseLevel;
-  }
+  inline G4double GetMinKinEnergy() const;
+
+  inline void SetMinKinEnergy(G4double value);
+
+  inline G4double GetMaxKinEnergy() const;
+
+  inline void SetMaxKinEnergy(G4double value);
+
+  inline const G4String& GetName() const;
 
 protected:
 
   G4int verboseLevel;
+
+private:
+
+  G4VCrossSectionDataSet & operator=(const G4VCrossSectionDataSet &right);
+  G4VCrossSectionDataSet(const G4VCrossSectionDataSet&);
+
+  G4double minKinEnergy;
+  G4double maxKinEnergy;
+
+  const G4String name;
 };
 
+inline void G4VCrossSectionDataSet::SetVerboseLevel(G4int value)
+{
+  verboseLevel = value;
+}
+
+inline void G4VCrossSectionDataSet::SetMinKinEnergy(G4double value)
+{
+  minKinEnergy = value;
+}
+
+inline G4double G4VCrossSectionDataSet::GetMinKinEnergy() const
+{
+  return minKinEnergy;
+}
+
+inline void G4VCrossSectionDataSet::SetMaxKinEnergy(G4double value)
+{
+  maxKinEnergy = value;
+}
+
+inline G4double G4VCrossSectionDataSet::GetMaxKinEnergy() const
+{
+  return maxKinEnergy;
+}
+
+inline const G4String& G4VCrossSectionDataSet::GetName() const
+{
+  return name;
+}
+
 #endif
Index: trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonElasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonElasticXS.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonElasticXS.cc	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BGGNucleonElasticXS.cc,v 1.7 2009/11/19 19:40:45 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4BGGNucleonElasticXS.cc,v 1.8 2010/10/12 06:02:41 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -51,5 +51,4 @@
 #include "G4NistManager.hh"
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
 G4BGGNucleonElasticXS::G4BGGNucleonElasticXS(const G4ParticleDefinition*) 
@@ -75,22 +74,19 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4double G4BGGNucleonElasticXS::GetIsoZACrossSection(const G4DynamicParticle* dp, 
-						       G4double Z,
-						       G4double A, 
-						       G4double)
+
+G4double
+G4BGGNucleonElasticXS::GetZandACrossSection(const G4DynamicParticle* dp,
+                                            G4int Z, G4int A, G4double)
 {
   G4double cross = 0.0;
   G4double ekin = dp->GetKineticEnergy();
-  G4int iz = G4int(Z);
-  if(iz > 92) iz = 92;
+  if(Z > 92) Z = 92;
 
   if(ekin <= fLowEnergy) {
-    cross = theCoulombFac[iz];
+    cross = theCoulombFac[Z];
     if(isProton) { cross *= CoulombFactor(ekin, A); }
 
-  } else if(iz == 1) {
-    if( A < 1.5) {
+  } else if(Z == 1) {
+    if( A < 2) {
       fHadron->GetHadronNucleonXscNS(dp, G4Proton::Proton());
       cross = fHadron->GetElasticHadronNucleonXsc();
@@ -102,5 +98,5 @@
     }
   } else if(ekin > fGlauberEnergy) {
-    cross = theGlauberFac[iz]*fGlauber->GetElasticGlauberGribov(dp, Z, A);
+    cross = theGlauberFac[Z]*fGlauber->GetElasticGlauberGribov(dp, Z, A);
   } else {
     cross = fNucleon->GetElasticCrossSection(dp, Z, A);
@@ -159,5 +155,6 @@
   G4NistManager* nist = G4NistManager::Instance();
 
-  G4double A, csup, csdn;
+  G4double csup, csdn;
+  G4int A;
 
   if(verboseLevel > 0) G4cout << "### G4BGGNucleonElasticXS::Initialise for "
@@ -167,8 +164,8 @@
 
     G4double Z = G4double(iz);
-    A = nist->GetAtomicMassAmu(iz);
-
-    csup = fGlauber->GetElasticGlauberGribov(&dp, Z, A);
-    csdn = fNucleon->GetElasticCrossSection(&dp, Z, A);
+    A = G4lrint(nist->GetAtomicMassAmu(iz));
+
+    csup = fGlauber->GetElasticGlauberGribov(&dp, iz, A);
+    csdn = fNucleon->GetElasticCrossSection(&dp, iz, A);
 
     theGlauberFac[iz] = csdn/csup;
@@ -179,12 +176,12 @@
   fHadron->GetHadronNucleonXscNS(&dp, G4Proton::Proton());
   theCoulombFac[1] = fHadron->GetElasticHadronNucleonXsc();
-  if(isProton) { theCoulombFac[1] /= CoulombFactor(fLowEnergy, 1.0); }
+  if(isProton) { theCoulombFac[1] /= CoulombFactor(fLowEnergy, 1); }
 
   for(G4int iz=2; iz<93; iz++) {
 
     G4double Z = G4double(iz);
-    A = nist->GetAtomicMassAmu(iz);
-
-    theCoulombFac[iz] = fNucleon->GetElasticCrossSection(&dp, Z, A);
+    A = G4lrint(nist->GetAtomicMassAmu(iz));
+
+    theCoulombFac[iz] = fNucleon->GetElasticCrossSection(&dp, iz, A);
     if(isProton) { theCoulombFac[iz] /= CoulombFactor(fLowEnergy, A); }
     if(verboseLevel > 0) G4cout << "Z= " << Z <<  "  A= " << A 
@@ -195,25 +192,24 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-G4double G4BGGNucleonElasticXS::CoulombFactor(G4double kinEnergy, G4double A)
-{
-  G4double res= 0.0;
+G4double G4BGGNucleonElasticXS::CoulombFactor(G4double kinEnergy, G4int A)
+{
+  G4double res = 0.0;
   if(kinEnergy <= DBL_MIN) return res;
-  else if(A < 1.5) return kinEnergy*kinEnergy;
+  else if(A < 2) return kinEnergy*kinEnergy;
 
   G4double elog = std::log10(kinEnergy/GeV);
+  G4double aa = A;
 
   // from G4ProtonInelasticCrossSection
-  G4double f1 = 8.0  - 8.0/A - 0.008*A;
-  G4double f2 = 2.34 - 5.4/A - 0.0028*A;
+  G4double f1 = 8.0  - 8.0/aa - 0.008*aa;
+  G4double f2 = 2.34 - 5.4/aa - 0.0028*aa;
 
   res = 1.0/(1.0 + std::exp(-f1*(elog + f2)));
  
-  f1 = 5.6 - 0.016*A;
-  f2 = 1.37 + 1.37/A;
-  res *= ( 1.0 + (0.8 + 18./A - 0.002*A)/(1.0 + std::exp(f1*(elog + f2))));
+  f1 = 5.6 - 0.016*aa;
+  f2 = 1.37 + 1.37/aa;
+  res *= ( 1.0 + (0.8 + 18./aa - 0.002*aa)/(1.0 + std::exp(f1*(elog + f2))));
   return res;  
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-
+
Index: trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonInelasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonInelasticXS.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4BGGNucleonInelasticXS.cc	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BGGNucleonInelasticXS.cc,v 1.7 2009/11/19 19:40:45 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4BGGNucleonInelasticXS.cc,v 1.9 2010/10/12 06:16:19 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -75,20 +75,18 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4double G4BGGNucleonInelasticXS::GetIsoZACrossSection(const G4DynamicParticle* dp, 
-						       G4double Z,
-						       G4double A, 
-						       G4double)
+
+G4double
+G4BGGNucleonInelasticXS::GetZandACrossSection(const G4DynamicParticle* dp,
+                                              G4int Z, G4int A, G4double)
 {
   G4double cross = 0.0;
   G4double ekin = dp->GetKineticEnergy();
-  G4int iz = G4int(Z);
-  if(iz > 92) iz = 92;
+//  G4int iz = G4int(Z);
+  if(Z > 92) Z = 92;
 
   if(ekin <= fLowEnergy) {
-    cross = theCoulombFac[iz]*CoulombFactor(ekin, A);
-  } else if(iz == 1) {
-    if( A < 1.5) {
+    cross = theCoulombFac[Z]*CoulombFactor(ekin, A);
+  } else if(Z == 1) {
+    if( A < 2) {
       fHadron->GetHadronNucleonXscNS(dp, G4Proton::Proton());
       cross = fHadron->GetInelasticHadronNucleonXsc();
@@ -100,7 +98,7 @@
     }
   } else if(ekin > fGlauberEnergy) {
-    cross = theGlauberFac[iz]*fGlauber->GetInelasticGlauberGribov(dp, Z, A);
+    cross = theGlauberFac[Z]*fGlauber->GetInelasticGlauberGribov(dp, Z, A);
   } else {
-    cross = fNucleon->GetIsoZACrossSection(dp, Z, A);
+    cross = fNucleon->GetZandACrossSection(dp, Z, A);
   }
 
@@ -156,5 +154,5 @@
 
   G4NistManager* nist = G4NistManager::Instance();
-  G4double A = nist->GetAtomicMassAmu(2);
+  G4int A = G4lrint(nist->GetAtomicMassAmu(2));
 
   G4double csup, csdn;
@@ -166,8 +164,9 @@
 
     G4double Z = G4double(iz);
-    A = nist->GetAtomicMassAmu(iz);
-
-    csup = fGlauber->GetInelasticGlauberGribov(&dp, Z, A);
-    csdn = fNucleon->GetIsoZACrossSection(&dp, Z, A);
+    A = G4lrint(nist->GetAtomicMassAmu(iz));
+
+    csup = fGlauber->GetInelasticGlauberGribov(&dp, iz, A);
+//    csdn = fNucleon->GetIsoZACrossSection(&dp, Z, A);
+    csdn = fNucleon->GetZandACrossSection(&dp, iz, A);
 
     theGlauberFac[iz] = csdn/csup;
@@ -178,13 +177,13 @@
   fHadron->GetHadronNucleonXscNS(&dp, G4Proton::Proton());
   theCoulombFac[1] = 
-    fHadron->GetInelasticHadronNucleonXsc()/CoulombFactor(fLowEnergy,1.0);
+    fHadron->GetInelasticHadronNucleonXsc()/CoulombFactor(fLowEnergy,1);
      
   for(G4int iz=2; iz<93; iz++) {
 
     G4double Z = G4double(iz);
-    A = nist->GetAtomicMassAmu(iz);
+    A = G4lrint(nist->GetAtomicMassAmu(iz));
 
     theCoulombFac[iz] = 
-      fNucleon->GetIsoZACrossSection(&dp, Z, A)/CoulombFactor(fLowEnergy,A);
+      fNucleon->GetZandACrossSection(&dp, iz, A)/CoulombFactor(fLowEnergy,A);
 
     if(verboseLevel > 0) G4cout << "Z= " << Z <<  "  A= " << A 
@@ -193,31 +192,31 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4double G4BGGNucleonInelasticXS::CoulombFactor(G4double kinEnergy, G4double A)
+
+G4double G4BGGNucleonInelasticXS::CoulombFactor(G4double kinEnergy, G4int A)
 {
   G4double res= 0.0;
   if(kinEnergy <= DBL_MIN) return res;
-  else if (A < 1.5) return kinEnergy*kinEnergy;
+  else if (A < 2) return kinEnergy*kinEnergy;
   
   G4double elog = std::log10(kinEnergy/GeV);
+  G4double aa = A;
 
   // from G4ProtonInelasticCrossSection
   if(isProton) {
-    G4double f1 = 8.0  - 8.0/A - 0.008*A;
-    G4double f2 = 2.34 - 5.4/A - 0.0028*A;
+    G4double f1 = 8.0  - 8.0/aa - 0.008*aa;
+    G4double f2 = 2.34 - 5.4/aa - 0.0028*aa;
 
     res = 1.0/(1.0 + std::exp(-f1*(elog + f2)));
  
-    f1 = 5.6 - 0.016*A;
-    f2 = 1.37 + 1.37/A;
-    res *= ( 1.0 + (0.8 + 18./A - 0.002*A)/(1.0 + std::exp(f1*(elog + f2))));
+    f1 = 5.6 - 0.016*aa;
+    f2 = 1.37 + 1.37/aa;
+    res *= ( 1.0 + (0.8 + 18./aa - 0.002*aa)/(1.0 + std::exp(f1*(elog + f2))));
   } else {
 
-    G4double p3 = 0.6 + 13./A - 0.0005*A;
-    G4double p4 = 7.2449 - 0.018242*A;
-    G4double p5 = 1.36 + 1.8/A + 0.0005*A;
-    G4double p6 = 1. + 200./A + 0.02*A;
-    G4double p7 = 3.0 - (A-70.)*(A-200.)/11000.;
+    G4double p3 = 0.6 + 13./aa - 0.0005*aa;
+    G4double p4 = 7.2449 - 0.018242*aa;
+    G4double p5 = 1.36 + 1.8/aa + 0.0005*aa;
+    G4double p6 = 1. + 200./aa + 0.02*aa;
+    G4double p7 = 3.0 - (aa-70.)*(aa-200.)/11000.;
 
     res = (1.+p3/(1. + std::exp(p4*(elog+p5))))/(1.+std::exp(-p6*(elog+p7)));
@@ -227,4 +226,2 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
